//Datei: InitPIC.c
//
// Grundeinstellung des PIC
//
// Copyright 1999 by Holger Klabunde
// 02.05.2001
// Compiler CC5x


#include "prozess.h"      /* Der verwendete Prozessor */

#include "ds1821.h"
#include "protos.h"

//**************************************************
//**************************************************
//PIC Grundeinstellungen
//**************************************************
//**************************************************
void InitPIC()
{

 CLRWDT;         //Laut Datenblatt vor ndern Prescaler fr TMR0
 OPTION=0b11010110;	 //Prescaler 1:128 und Intern Clock fr TMR0	
 
// Der Takt des PIC betrgt 4MHz
// Ein Maschinenzyklus damit 1us

 //Ein TimerClock = 1us * 128 = 128us
 //TMR0 Interrupt alle 256 * 128us = 33ms
 //33ms * 30 = 1s
 
 TRISA=0x0F; // PortA 	alles Eingnge auer RA4
 TRISB=0b01000000; // PortB 	alles Ausgnge auer PB6 

 PORTB=0x00;    //Definierten Zustand einstellen
 PORTA=0x0F;   

 INTCON=0b00100000; //TMR0 Interrupt
}